﻿Type=Class
Version=3
@EndOfDesignText@
'Class module

'code to put in the calling activity:
'************************************************************
' declare your msg object in globals
'
'Sub Activity_Resume
'mymsg.initialize(Me, "mymsg", Colors.black ,Colors.yellow, 24, Colors.White, 20 ,Colors.black, Activity)
'mymsg.SetScale(1.2) ' optional
'end sub
'
'Sub Activity_KeyPress (KeyCode As Int) As Boolean 'return true if you want to consume the event
'If KeyCode = KeyCodes.KEYCODE_BACK Then
'	 mymsg.set_type(False)
'    mymsg.Show("Exit","Do you want to exit ?",	LoadBitmap(File.DirAssets,"Warning-icon.png"),"Yes","", "No")
'End If
'Return True
'End Sub
'
'Sub mymsg_results(result As Int)
'If result = DialogResponse.POSITIVE Then Activity.Finish
'mymsg.set_type(True)  ' critical to return the type to true for other messages.
'End Sub
'
'use: 
'if mymsg.Show("Vote","Do you like this message ?",	LoadBitmap(File.DirAssets,"warningicon.png"),"Yes","Cancel", "No") = DialogResponse.POSITIVE Then...
'
'middle or right buttons will not appear if their text is "" .

'*****************************************************************************
'Note: use only after activity_resume is done, otherwise it is ignored by the OS.
'*************************************************************************
Sub Class_Globals
Private MModule As Object
Private background,frame , p, line  As Panel	
Private btn(3) As Button
Private titlelbl, msglbl As Label
Private iv As ImageView
Private result As Int = 0
Private scale, SF As Float 
Private ModalMsg As Boolean = True ' not using the return sub in the main activity
Private event As String
Private AW, AH As Int
Private cb As CheckBox
End Sub

'Initializes the object.
Public Sub Initialize(Module As Object, Eventname As String,FrameColor As Int, TitleColor As Int, TitleSize As Int, MsgColor As Int, MsgSize As Int,LineColor As Int, Parent As activity)

AW = Parent.Width
AH = Parent.Height

Dim clr(2) As Int
Dim dw As GradientDrawable

SF =  1.2 * Max(AW,AH)/800/Density 
scale = SF
MModule = Module
event = Eventname
background.Initialize("bg")
Parent.AddView(background, 0,0,100%x,100%y)
frame.Initialize("")
iv.Initialize("")
p.Initialize("")
line.Initialize("")
titlelbl.Initialize("")
msglbl.Initialize("")

background.Color = Colors.ARGB(170,0,0,0)
frame.Color = FrameColor
p.Color = Colors.DarkGray
titlelbl.TextSize = TitleSize * scale
titlelbl.TextColor = TitleColor
titlelbl.Gravity = Gravity.CENTER
msglbl.TextSize = MsgSize * scale
msglbl.TextColor = MsgColor
msglbl.Gravity = Gravity.CENTER_HORIZONTAL
line.Color = LineColor
clr(0) = Colors.white
clr(1) = Colors.RGB(80,80,80)
dw.Initialize("TOP_BOTTOM",clr)
dw.CornerRadius = 5dip
For i = 0 To 2
	btn(i).Initialize("button")
	btn(i).background = dw
	btn(i).TextSize = MsgSize * scale
	btn(i).Textcolor = Colors.black
	
Next
btn(0).Tag = DialogResponse.POSITIVE
btn(1).Tag = DialogResponse.CANCEL
btn(2).Tag = DialogResponse.NEGATIVE

iv.Gravity = Gravity.FILL

cb.Initialize("cb")
cb.Text = "Don't show again"
cb.Checked = False
cb.TextSize = MsgSize * scale - 4

background.AddView(frame,AW/2-130dip*scale, AH/2-105dip*scale, 250dip*scale, 210dip*scale)
frame.AddView(p,5dip*scale, 5dip*scale,240dip*scale,200dip*scale)
p.AddView(iv,15dip*scale,5dip*scale,40dip*scale,40dip*scale)
p.AddView(titlelbl,70dip*scale,5dip*scale,165dip*scale,40dip*scale)
p.AddView(line,0,50dip*scale,p.Width,3dip*scale)
p.AddView(msglbl,5dip*scale,60dip*scale,230dip*scale,50dip*scale)
p.AddView(btn(0),5dip*scale,145dip*scale,73dip*scale,50dip*scale)
p.AddView(btn(1),83dip*scale,145dip*scale,74dip*scale,50dip*scale)
p.AddView(btn(2),162dip*scale,145dip*scale,73dip*scale,50dip*scale)
p.AddView(cb,10dip*scale,100dip*scale,230dip*scale,30dip*scale)
background.Visible = False
End Sub

'If True - will not use the return sub in the main activity, but return the call from  "Show" .
Public Sub set_type(Modal As Boolean)
ModalMsg = Modal 
End Sub

'Increase or Decrease the dialog size, but keeps it centered. SizeFactor = 1 is no change.
Public Sub SetScale(SizeFactor As Float)
scale = SF * SizeFactor
frame.SetLayout(AW/2-130dip*scale, AH/2-105dip*scale, 250dip*scale, 210dip*scale)
p.SetLayout(5dip*scale, 5dip*scale,240dip*scale,200dip*scale)
iv.SetLayout(15dip*scale,5dip*scale,40dip*scale,40dip*scale)
titlelbl.SetLayout(70dip*scale,5dip*scale,165dip*scale,40dip*scale)
line.SetLayout(0,50dip*scale,p.Width,3dip*scale)
msglbl.SetLayout(5dip*scale,60dip*scale,230dip*scale,80dip*scale)
btn(0).SetLayout(5dip*scale,145dip*scale,73dip*scale,50dip*scale)
btn(1).SetLayout(83dip*scale,145dip*scale,74dip*scale,50dip*scale)
btn(2).SetLayout(162dip*scale,145dip*scale,73dip*scale,50dip*scale)
cb.SetLayout(10dip*scale,100dip*scale,230dip*scale,30dip*scale)
End Sub

'If midtext or righttext are passed as "" - the buttons will not show.
Public Sub Show(Title As String, Text As String, Bitmap As Bitmap, LeftText As String, MidText As String, RightText As String) As Int 'ignore
titlelbl.Text = Title
msglbl.Text = Text
btn(0).Text = LeftText
If MidText = "" Then
	btn(1).Visible = False
	If RightText = "" Then
		btn(2).Visible = False
		btn(0).Left = 65dip*scale
		btn(0).Width = 110dip*scale
	Else
		btn(0).SetLayout(5dip*scale,145dip*scale,110dip*scale,50dip*scale)
		btn(2).SetLayout(125dip*scale,145dip*scale,110dip*scale,50dip*scale)
		btn(2).Text = RightText
		btn(2).Visible = True
	End If
Else
	btn(0).SetLayout(5dip*scale,145dip*scale,73dip*scale,50dip*scale)
	btn(1).SetLayout(83dip*scale,145dip*scale,74dip*scale,50dip*scale)
	btn(2).SetLayout(162dip*scale,145dip*scale,73dip*scale,50dip*scale)
	btn(1).Text = MidText
	btn(2).Text = RightText
	btn(1).Visible = True
	btn(2).Visible = True
End If 

If Bitmap.IsInitialized Then
	iv.Bitmap = Bitmap
	iv.Visible = True
	titlelbl.Left = 70dip*scale
	titlelbl.Width = 165dip*scale
	titlelbl.Gravity = Gravity.LEFT
Else
	iv.Visible = False
	titlelbl.Left = 5dip*scale
	titlelbl.Width = 230dip*scale
	titlelbl.Gravity = Gravity.CENTER_HORIZONTAL
End If
background.Visible = True
background.BringToFront
If ModalMsg Then
	result = 0
	Do While result = 0
		DoEvents
	Loop
	Return result
End If
End Sub

'Returns the background panel as a view
Public Sub AsView As View
Return background
End Sub

'Sets the TextSize of the message
Public Sub Set_Button_Font_Size(FontSize As Int)
For i = 0 To 2
	btn(i).TextSize = FontSize * scale
Next
End Sub

'Sets the color of the frame
Public Sub Frame_Color(color As Int)
frame.color = color
End Sub

'Sets the color of the line between the title and the message
Public Sub Line_Color(color As Int)
line.color = color
End Sub

Private Sub button_click
Dim B As Button
B = Sender
If cb.Checked Then
	result = -1 *  B.Tag 
Else
	result = B.Tag
End If
If ModalMsg = False Then CallSub2(MModule,event & "_results",result)
background.Visible = False
End Sub

Private Sub bg_click
End Sub

Private Sub bg_long_click
End Sub




